      SUBROUTINE INVRT(A, AM1, IM) 
!-----------------------------------------------
!   M o d u l e s 
!-----------------------------------------------
      USE vast_kind_param
      USE params_M 
!...Translated by Pacific-Sierra Research 77to90  4.4D  16:36:33   4/10/03  
!...Switches: -yf12               
!       Implicit Real*8(A-H,O-Z)
!       Real*8 A(iM,iM), Am1(iM,iM)
!      Implicit REAL ( KIND=8 ) (A-H,O-Z)
 
      IMPLICIT NONE
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      INTEGER  :: IM 
      REAL(DOUBLE)  :: A(IM,IM) 
      REAL(DOUBLE)  :: AM1(IM,IM) 
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      INTEGER , DIMENSION(IM) :: IWK1 
      INTEGER , DIMENSION(IM*2) :: IWK2 
      INTEGER :: IZERO, IDET, IDUM 
      REAL(DOUBLE), DIMENSION(IM,IM) :: DUM 
      REAL(DOUBLE) :: DET 
!-----------------------------------------------
!
 
      IZERO = 0 
      IDET = 1 
      AM1(:IM,:IM) = A(:IM,:IM) 
      CALL MATINV (IM, IM, AM1, IZERO, DUM, IDET, DET, IDUM, IWK1, IWK2) 
      IF (DET == 0.D0) THEN
      	WRITE (16, *) ' INVRT: ERROR... MATRIX IS SINGULAR...EXITING'
      	STOP "INVRT: ERROR... MATRIX IS SINGULAR...EXITING"
      	ENDIF
      RETURN  
      END SUBROUTINE INVRT 
