      PROGRAM RDRV 
!-----------------------------------------------
!   M o d u l e s 
!-----------------------------------------------
      USE vast_kind_param
      USE params_M 
      USE tfiles_dat_M 
!...Translated by Pacific-Sierra Research 77to90  4.4D  16:36:33   4/10/03  
!...Switches: -yf12               
      IMPLICIT NONE
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      INTEGER :: NFIT, NVAR, NLEV, UFLAG, UGAS, GASOUTTYPE
      REAL(DOUBLE) :: UVAL
      REAL(DOUBLE), DIMENSION(MMAX) :: YHAT 
      REAL(DOUBLE), DIMENSION(NMAX) :: XHAT 
      LOGICAL :: RETFLG, WRTK, WRTSA, WRTGASFILES 
      CHARACTER :: CTLFIL*(IFLNMSZ), PT*(IFLNMSZ), MX*(IFLNMSZ), &
                   MS*(IFLNMSZ), INP_SPC*(IFLNMSZ), OUT_SPC*(IFLNMSZ) 
!-----------------------------------------------

! prompt for file names
      TFIL61 =  '-not_used-'        ! default SA output filename 
      TFIL66 =  '-not_used-'        ! default K,Se,Sa matrices output filename 
      TFIL68 =  '-not_used-'        ! default K transposed filename 
      OUT_SPC = '-not_used-'        ! saved synthetic spectrum
     
      GASOUTTYPE=0 
      OPEN(1, FILE='rdrv.ctl', STATUS='old', ERR=1000, POSITION='asis') 
      READ (1, 10) CTLFIL 
      READ (1, 10) PT 
      READ (1, 10) MS 
      READ (1, 10) MX 
      READ (1, 10) INP_SPC 
      READ (1, *) RETFLG 
      IF (.NOT.RETFLG) READ (1, 10) OUT_SPC 
      READ (1, *) WRTK 
      IF (WRTK) READ (1, 10) TFIL66 
      WRTSA = .FALSE. 
      READ (1, *, END=100) WRTSA 
      IF (WRTSA) READ (1, 10) TFIL61 
      READ (1, *, END=100) WRTGASFILES 
      IF (WRTGASFILES) READ (1, *)  GASOUTTYPE
      UFLAG = 0
      UGAS = 0
      UVAL = 0.0
      READ (1,*, END=100) UFLAG, UGAS, UVAL
      
  100 CONTINUE 
      CLOSE(1) 

      XHAT(:NMAX) = 0.0D0
      YHAT(:MMAX) = 0.0D0      
      CALL SFIT2 (CTLFIL, INP_SPC, OUT_SPC, PT, MS, MX, XHAT, YHAT, NFIT, NVAR&
         , NLEV, RETFLG, WRTK, WRTSA, UFLAG, UGAS, UVAL, GASOUTTYPE) 

      GO TO 30 
 1000 CONTINUE 
      WRITE (*, *) 'Cannot open "rdrv.ctl"' 
      STOP  
   30 CONTINUE 
      STOP  
   10 FORMAT(A) 
!   20 FORMAT(A7) 
      END PROGRAM RDRV 
