      SUBROUTINE BOBAPD 
!-----------------------------------------------
!   M o d u l e s 
!-----------------------------------------------
      USE vast_kind_param
      USE params_M 
      USE jmix_dat_M
      USE zfft_dat_M
      USE ils_dat_M 
!...Translated by Pacific-Sierra Research 77to90  4.4D  16:36:33   4/10/03  
!...Switches: -yf12               
 
      IMPLICIT NONE
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      INTEGER :: IAP1 
!-----------------------------------------------
!
 
!  --- RETRIEVE NORTON AND BEER APODIZING FUNCTIONS - REVISED FEB 22, 1990
      IAP1 = IAP + 1 
      SELECT CASE (IAP1)  
!  IAP=0 (BOX CAR APODIZATION)
      CASE DEFAULT 
         C0 = 1.D0 
         C1 = 0.D0 
         C2 = 0.D0 
         C4 = 0.D0 
         RETURN  
!  IAP=1  (WEAK APODIZATION)
      CASE (2)  
         C0 = 0.384093D0 
         C1 = -0.087577D0 
         C2 = 0.703484D0 
         C4 = 0.D0 
         RETURN  
!  IAP=2 (MODERATE APODIZATION)
      CASE (3)  
         C0 = 0.152442D0 
         C1 = -0.136176D0 
         C2 = 0.983734D0 
         C4 = 0.D0 
         RETURN  
!  IAP=3 (STRONG APODIZATION)
      CASE (4)  
         C0 = 0.045335D0 
         C1 = 0.D0 
         C2 = 0.554883D0 
         C4 = 0.399782D0 
         RETURN  
!  IAP=4 (DENVER DATA)
      CASE (5)  
         C0 = 0.D0 
         C1 = 0.D0 
         C2 = 1.D0 
         C4 = 0.D0 
         RETURN  
      END SELECT 
      END SUBROUTINE BOBAPD 
