      MODULE slat_dat_M 
! variable data by layer

! MAXSPE	: MAXIMUM NUMBER OF SPECTRA
! MOLMAX	: MAXIMUM NUMBER OF RETRIEVAL GASES
! LAYMAX	: MAXIMUM NUMBER OF LAYERS
      USE vast_kind_param
!...Created by Pacific-Sierra Research 77to90  4.4D  16:36:33   4/10/03  
      USE params_M
      REAL(DOUBLE), DIMENSION(MAXSPE,LAYMAX) :: CCC  ! MASS PATH
      REAL(DOUBLE), DIMENSION(LAYMAX) :: PMASMX      ! MAXIMUM MASS
      REAL(DOUBLE), DIMENSION(LAYMAX) :: Z           ! LAYER LOWER BOUNDRY (KM)
      REAL(DOUBLE), DIMENSION(LAYMAX) :: ZM          ! LAYER MIDPOINT (KM)
      REAL(DOUBLE), DIMENSION(LAYMAX) :: P           ! PRESSURE WEIGHTED PRESSURE (ATM)
      REAL(DOUBLE), DIMENSION(LAYMAX) :: T           ! PRESSURE WEIGHTED TEMPERATURE (K)
      REAL(DOUBLE), DIMENSION(LAYMAX) :: PMB         ! PRESSURE WEIGHTED PRESSURE (MB)
      REAL(DOUBLE), DIMENSION(MOLMAX,LAYMAX) :: XORG ! INITIAL VALUES MIXING RATIOS - FITTED
      REAL(DOUBLE), DIMENSION(MOLMAX,LAYMAX) :: X    ! WORKING VALUES MIXING RATIOS - FITTED
      REAL(DOUBLE), DIMENSION(MAXGAS,LAYMAX) :: XGAS ! INITIAL VALUES MIXING RATIOS - ALL
      LOGICAL :: FIXFORMAT 
      INTEGER :: MIXFORMAT 
      END MODULE slat_dat_M 
